package atomes;

import classement.EnsembleTrie;
import espace3D.Vecteur3D;
import photons.Dispositif_Laser;

/**
 * classe drive de la classe action
 * implante une dsexcitation induite
 */
public class Desexind extends Action {
    Dispositif_Laser laser;
	double frequence;
    Vecteur3D direction;
    /**
     * Constructeur d'une action de dsexcitation induite
     * @param atome // atome concern
     * @param laser // dispositif laser en oeuvre
     */
    public Desexind(Atome atome, Dispositif_Laser laser){
        super(atome,0);
        this.laser = laser;
        this.frequence = 0;
        this.direction = null;
    }
    /**
     * mise  jour de l'action
     * (date frquence et direction)
     */
    public void set(double date, double frequence, Vecteur3D direction){
    	this.valeur = date;
    	this.frequence = frequence;
    	this.direction = direction;
    }
    /**
     * excution d'une desexcitation induite
     * et calcul de la prochaine excitation
     */
    public Action execute() {
        atome.desexind(valeur, -frequence, direction,0);
        return atome.prochaineexcitation(laser);
    }
    /**
     * incrmentation du compteur de desxcitations induites
     */
    public void incremente(int[]compteurs){
    	compteurs[1]= compteurs[1]+1;
    }
}
