package atomes;

import classement.EnsembleTrie;
import espace3D.Vecteur3D;
import photons.Dispositif_Laser;

/**
 * classe drive de la classe Action,
 * implante une excitation 
 */
public class Exitation extends Action {
    //-------------
	Dispositif_Laser laser;
    Vecteur3D direction;
    double frequence;
    /**
     * Constructeur d'une action d'excitation
     * @param atome // atome concern
     * @param laser // dispositif laser en oeuvre
     */
    public Exitation(Atome atome, Dispositif_Laser laser){
        super(atome,0);
        this.laser = laser;
        this.frequence = 0;
        this.direction = null;
    }
    /**
     * mise  jour de l'action
     * (date frquence et direction)
     */
    public void set(double date, double frequence, Vecteur3D direction){
    	this.valeur = date;
    	this.frequence = frequence;
    	this.direction = direction;
    }
    /**
     * excution de l'excitation et calcul de la prochaine desexcitation
     */
    public Action execute() {
        atome.excite(valeur, frequence, direction,1);
        return atome.prochainedesexcitation(laser);
    }
    /**
     * incrmentation du compteur d'excitations
     */
    public void incremente(int[]compteurs){
    	compteurs[0]= compteurs[0]+1;
    }
}
