 package classement;
	/**
	 * Chaque Noeud est le conteneur d'un lment affect d'une valeur et divise l'intervalle 
	 * jusqu' cette valeur en deux intervalles ]-infini, t0] et ]t0,t]
	 * reprsents respectivement par le fils gauche et le fils droit
	 * de ce noeud dans une hirarchie binaire
	 * Si le fils gauche n'existe pas (pas de mesure infrieure  t,
	 * et donc pas de t0) il en est ncessairement de mme pour le fils droit
	 * (inspir de l'Algorithme de tri de Dijsktra)
	 */
	public class Noeud {
	    //fils gauche
	    private Noeud gauche;
	    //fils droit (le plus proche dans le temps)
	    private Noeud droit;
	    //ascendant
	    private Noeud ascendant;
	    //lment enregistr
	    private Element element;
	    //--------
	    // Constructeurs
	    public Noeud(Element el){
	    	this.gauche = null;
	    	this.droit = null;
	    	this.ascendant = null;
	    	this.element = el;
	    }
	    public Noeud(Element el, Noeud gauche, Noeud ascendant, int signe){
	    	el.set_place(this);
			//information du noeud;
			this.element = el;
			this.gauche = gauche;
			this.droit = null;
			this.ascendant = ascendant;
			//information de son ascendant;
			//if(ascendant != null){
				if(signe == -1){
					ascendant.set_gauche(this);
				}
				if(signe == 1){
					ascendant.set_droit(this);
				}
			//}
	    }
	    //-------------------------
	    public Element get_element(){return element;}
	    public void set_element(Element el){element = el;}
	    public void set_gauche(Noeud gche){gauche = gche;}
	    public void set_droit(Noeud droi){droit = droi;}
	    public void set_ascendant(Noeud ascd){ascendant = ascd;}
	    //-------------------------
	    public double get_t(){return element.get_valeur();}
	    public double get_t0(){
	        return gauche.get_t();
	    }
	    public Noeud get_droit(){
	        return droit;
	    }
	    public Noeud get_gauche(){
	        return gauche;
	    }
	    public Noeud get_ascend(){
	        return ascendant;
	    }
	    public Noeud get_frere(){
	    	return ascendant.get_droit();
	    }
	    /**
	     * insertion d'un lement dans la hirachie binaire des noeuds 
	     * en prenant comme point de dpart le noeud courant.
	     * l'opration s'effectue sans destruction du noeud, 
	     * qui conserve son lment.
	     * @param el lment  insrer;
	     */
	    public void insertion(Element el){
	    	double date = el.get_valeur();
	    	//si la valeur de l'lement est suprieure  t
	        //j'insre l'lement dans un nouveau noeud qui sera
	        //le nouveau fils droit de l'ascendant du noeud courant
	        //et qui aura le noeud courant comme fils gauche
	    	if(date > get_t()){
	    		ascendant = new Noeud(el,this,ascendant,+1);
	    		return;
	    	}
	    	//si le noeud courant est (provisoirement) un noeud final
	    	//j'insre l'lement dans un nouveau noeud 
			// plac comme fils gauche du noeud courant
	    	if(gauche == null){
	    		new Noeud(el,null,this,-1);
	    		return;
	    	}
	    	//si la valeur de l'lement est infrieure ou gale  t0
	    	//j'insre l'lement sur la gauche du noeud courant
	    	if(date<=get_t0()){
	    		gauche.insertion(el);
	    		return;
	    	}
	    	//si la valeur de l'lement est infrieure ou gale  t
	    	//j'insre l'lement sur la droite du noeud courant
	        if(date<=get_t()){
	        	if(droit == null){
	    	        new Noeud(el,null,this,+1);
	    	        return;
	        	}
	        	droit.insertion(el);
	        	return;
	        }
	    }
		/**
		 * remonte  partir du noeud courant au noeud suivant dans l'ordre du tri
		 */
	    public void depilement(){
	    //repositionnement du frre ventuel
	        Noeud frere = get_frere();
	        ascendant.set_gauche(frere);
	        ascendant.set_droit(null);
	    }
		/**
		 * descente dans le sous arbre ayant pour raine le noeud courant 
		 * jusqu'au premier noeud dans l'ordre du tri
		 */
	    public Noeud get_first(){
	        if(gauche == null) return this;
	        return gauche.get_first();
	    }
}
