package fonctions;
/**
 * classe gnrale de fonction continue sur un domaine rell
 * @author jeanpierretreuil
 *
 */
public abstract class Fonction1D {
    protected Domaine1D domaine;
    public abstract double valeur(double x);
    /**
     * calcul de la valeur de la fonction 
     * pour une valeur de x appartenant au domaine
     * @param x
     * @return
     */
    public double f(double x) {
        if(domaine.estinclue(x)==false) {
            System.out.println("valeur non incluse dans le domaine");
            System.exit(1);
            return 0;
        }else{return valeur(x);}
	}
    /**
     * intgration par la mthode trapzoidale
     * @param a borne infrieure
     * @param b borne suprieure
     * @param h pas de discrtisation
     */
    public double integrale(double a, double b, double h){
        int n = (int)Math.ceil((b-a)/h);
        double hprime = (b-a)/n;
        double somme = 0.5*(f(a)+f(b));
        for (int i = 1; i<=n-1 ;i++){
    	    somme = somme +f(a+i*hprime);
        }
        return hprime*somme;	
    }
}
