package fonctions;
import java.util.Random;

public class Tirages {
	public static Random tirage = new Random();
	/**
     * tirage selon une loi de probabilit exponentielle
     * @param moyenne : moyenne de la loi
     * @return
     */
    public static double tirage_exponentiel(double moyenne){
        double y = tirage.nextDouble();
        double x = - (Math.log(1-y))*moyenne;
        return x;
    }
    /**
     * tirage d'une valeur alatoire gaussienne
     * @param moyenne de la distribution
     * @param largeur 
     * @param type : type de la largeur, fwhm ou bien sigma
     * @return
     */
    public static double tirage_gaussien(double moyenne, double largeur, String type) {
    	double sigma;
    	if(type == "fwhm"){
    	    //calcul de sigma
            double fwhm = moyenne*largeur;
            double coeff = 2*Math.sqrt(2*Math.log(2));
            sigma = fwhm/coeff;
        }else{
        	sigma = largeur;
        }
        double x = tirage.nextGaussian();
        return moyenne + sigma*x;
    }
    /**
     * tirage selon une loi de probabilit lorentzienne
     * de frquence centrale freqrs et de gamma = 1/tau
     * @param freqrs en GHZ
     * @param tau en nanosecondes
     * @return
     */
    public static double tirage_lorentzien(double freqres, double tau){
        double y = tirage.nextDouble();
        double df = (1/tau)*(1/(4*Math.PI))*Math.tan(Math.PI*y);
        return freqres+df;
    }
}
